import { zodResolver } from '@hookform/resolvers/zod'
import { useEffect, useState } from 'react'
import { useFetcher } from 'react-router'
import { RemixFormProvider, useRemixForm } from 'remix-hook-form'
import { z } from 'zod'

import { Button } from '~/components/ui/button'
import { Input } from '~/components/ui/input'
import type { NewsContextProperties } from '~/contexts/news'

export const loginSchema = z.object({
  email: z.string().email('Email tidak valid'),
  password: z.string().min(6, 'Kata sandi minimal 6 karakter'),
})

export type TLoginSchema = z.infer<typeof loginSchema>

type TProperties = {
  setIsRegisterOpen: NewsContextProperties['setIsRegisterOpen']
  setIsLoginOpen: NewsContextProperties['setIsLoginOpen']
  setIsForgetOpen: NewsContextProperties['setForgetOpen']
  setIsInitSubscribeOpen: NewsContextProperties['setIsInitSubscribeOpen']
}

export const FormLogin = (properties: TProperties) => {
  const {
    setIsRegisterOpen,
    setIsLoginOpen,
    setIsForgetOpen,
    setIsInitSubscribeOpen,
  } = properties
  const fetcher = useFetcher()
  const [error, setError] = useState<string>()
  const [disabled, setDisabled] = useState(false)

  const formMethods = useRemixForm<TLoginSchema>({
    mode: 'onSubmit',
    fetcher,
    resolver: zodResolver(loginSchema),
  })

  const { handleSubmit } = formMethods

  useEffect(() => {
    if (fetcher.state !== 'idle' || fetcher.data?.success) {
      setDisabled(true)
      return
    }
    setDisabled(false)
  }, [fetcher])

  useEffect(() => {
    if (fetcher.data?.success) {
      setIsInitSubscribeOpen(true)
      setIsLoginOpen(false)
      return
    }
    setError(fetcher.data?.message)
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [fetcher])

  return (
    <div className="flex items-center justify-center">
      <div className="w-full max-w-md">
        <RemixFormProvider {...formMethods}>
          <fetcher.Form
            method="post"
            onSubmit={handleSubmit}
            className="space-y-4"
            action="/actions/login"
          >
            <Input
              id="email"
              label="Email / No Telepon"
              placeholder="Contoh: legal@legalgo.id"
              name="email"
            />

            <Input
              id="password"
              label="Kata Sandi"
              placeholder="Masukkan Kata Sandi"
              name="password"
              type="password"
            />

            {error && (
              <div className="text-sm text-red-500 capitalize">{error}</div>
            )}

            {/* Lupa Kata Sandi */}
            <div className="flex items-center justify-between text-sm">
              <span className="text-gray-600">Lupa Kata Sandi?</span>
              <Button
                onClick={() => {
                  setIsLoginOpen(false)
                  setIsForgetOpen(true)
                }}
                className="font-semibold text-[#2E2F7C]"
                variant="link"
                size="fit"
              >
                Reset Kata Sandi
              </Button>
            </div>

            {/* Tombol Masuk */}
            <Button
              disabled={disabled}
              type="submit"
              className="w-full rounded-md bg-[#2E2F7C] py-2 text-white transition hover:bg-blue-800"
            >
              Masuk
            </Button>
          </fetcher.Form>
        </RemixFormProvider>

        {/* Link Daftar */}
        <div className="mt-4 text-center text-sm">
          Belum punya akun?{' '}
          <Button
            onClick={() => {
              setIsLoginOpen(false)
              setIsRegisterOpen(true)
            }}
            className="font-semibold text-[#2E2F7C]"
            variant="link"
            size="fit"
          >
            Daftar Disini
          </Button>
        </div>
      </div>
    </div>
  )
}
